OGRE: Ogre::Archive Class Reference - OGRE Documentation

Public Member Functions | Protected Attributes

# Ogre::Archive Class Reference
[Resources]

Archive-handling class. More...

`#include <OgreArchive.h>`

Inheritance diagram for Ogre::Archive:
[legend]

List of all members.

## Public Member Functions
| Archive (const String &name, const String &archType)
| Constructor - don't call direct, used by ArchiveFactory.
virtual | ~Archive ()
| Default destructor.
const String & | getName (void) const
| Get the name of this archive.
virtual bool | isCaseSensitive (void) const =0
| Returns whether this archive is case sensitive in the way it matches files.
virtual void | load ()=0
| Loads the archive.
virtual void | unload ()=0
| Unloads the archive.
virtual bool | isReadOnly () const
| Reports whether this Archive is read-only, or whether the contents can be updated.
virtual DataStreamPtr | open (const String &filename, bool readOnly=true) const =0
| Open a stream on a given file.
virtual DataStreamPtr | create (const String &filename) const
| Create a new file (or overwrite one already there).
virtual void | remove (const String &filename) const
| Delete a named file.
virtual StringVectorPtr | list (bool recursive=true, bool dirs=false)=0
| List all file names in the archive.
virtual FileInfoListPtr | listFileInfo (bool recursive=true, bool dirs=false)=0
| List all files in the archive with accompanying information.
virtual StringVectorPtr | find (const String &pattern, bool recursive=true, bool dirs=false)=0
| Find all file or directory names matching a given pattern in this archive.
virtual bool | exists (const String &filename)=0
| Find out if the named file exists (note: fully qualified filename required).
virtual time_t | getModifiedTime (const String &filename)=0
| Retrieve the modification time of a given file.
virtual FileInfoListPtr | findFileInfo (const String &pattern, bool recursive=true, bool dirs=false)=0
| Find all files or directories matching a given pattern in this archive and get some detailed information about them.
const String & | getType (void) const
| Return the type code of this Archive.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Attributes
String | mName
| Archive name.
String | mType
| Archive type code.
bool | mReadOnly
| Read-only flag.

## Detailed Description

Archive-handling class.

Remarks:
  An archive is a generic term for a container of files. This may be a filesystem folder, it may be a compressed archive, it may even be a remote location shared on the web. This class is designed to be subclassed to provide access to a range of file locations.

  Instances of this class are never constructed or even handled by end-user applications. They are constructed by custom ArchiveFactory classes, which plugins can register new instances of using ArchiveManager. End-user applications will typically use ResourceManager or ResourceGroupManager to manage resources at a higher level, rather than reading files directly through this class. Doing it this way allows you to benefit from OGRE's automatic searching of multiple file locations for the resources you are looking for.

Definition at line 87 of file OgreArchive.h.

## Constructor & Destructor Documentation

Ogre::Archive::Archive | ( | const String & | name,
|  | const String & | archType |
| ) |  |  |

Constructor - don't call direct, used by ArchiveFactory.

Definition at line 101 of file OgreArchive.h.

virtual Ogre::Archive::~Archive | ( |  | ) | `[virtual]`

Default destructor.

Definition at line 106 of file OgreArchive.h.

## Member Function Documentation

virtual DataStreamPtr Ogre::Archive::create | ( | const String & | filename | ) | const`[virtual]`

Create a new file (or overwrite one already there).

Note:
  If the archive is read-only then this method will fail.

Parameters:

  | filename | The fully qualified name of the file

Returns:
  A shared pointer to a DataStream which can be used to read / write the file.

Reimplemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

Definition at line 154 of file OgreArchive.h.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

virtual bool Ogre::Archive::exists | ( | const String & | filename | ) | `[pure virtual]`

Find out if the named file exists (note: fully qualified filename required).

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual StringVectorPtr Ogre::Archive::find | ( | const String & | pattern,
|  | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[pure virtual]`

Find all file or directory names matching a given pattern in this archive.

Note:
  This method only returns filenames, you can also retrieve other information using findFileInfo.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual FileInfoListPtr Ogre::Archive::findFileInfo | ( | const String & | pattern,
|  | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[pure virtual]`

Find all files or directories matching a given pattern in this archive and get some detailed information about them.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of file information structures for all files matching the criteria.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual time_t Ogre::Archive::getModifiedTime | ( | const String & | filename | ) | `[pure virtual]`

Retrieve the modification time of a given file.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

const String& Ogre::Archive::getName | ( | void |  | ) | const

Get the name of this archive.

Definition at line 109 of file OgreArchive.h.

const String& Ogre::Archive::getType | ( | void |  | ) | const

Return the type code of this Archive.

Definition at line 232 of file OgreArchive.h.

virtual bool Ogre::Archive::isCaseSensitive | ( | void |  | ) | const`[pure virtual]`

Returns whether this archive is case sensitive in the way it matches files.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual bool Ogre::Archive::isReadOnly | ( |  | ) | const`[virtual]`

Reports whether this Archive is read-only, or whether the contents can be updated.

Definition at line 133 of file OgreArchive.h.

virtual StringVectorPtr Ogre::Archive::list | ( | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[pure virtual]`

List all file names in the archive.

Note:
  This method only returns filenames, you can also retrieve other information using listFileInfo.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual FileInfoListPtr Ogre::Archive::listFileInfo | ( | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[pure virtual]`

List all files in the archive with accompanying information.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of structures detailing quite a lot of information about all the files in the archive.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual void Ogre::Archive::load | ( |  | ) | `[pure virtual]`

Loads the archive.

Remarks:
  This initializes all the internal data of the class.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

virtual DataStreamPtr Ogre::Archive::open | ( | const String & | filename,
|  | bool | readOnly = `true` |
| ) |  |  | const`[pure virtual]`

Open a stream on a given file.

Note:
  There is no equivalent 'close' method; the returned stream controls the lifecycle of this file operation.

Parameters:

  | filename | The fully qualified name of the file
  | readOnly | Whether to open the file in read-only mode or not (note, if the archive is read-only then this cannot be set to false)

Returns:
  A shared pointer to a DataStream which can be used to read / write the file. If the file is not present, returns a null shared pointer.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::Archive::remove | ( | const String & | filename | ) | const`[virtual]`

Delete a named file.

Remarks:
  Not possible on read-only archives

Parameters:

  | filename | The fully qualified name of the file

Reimplemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

Definition at line 166 of file OgreArchive.h.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

virtual void Ogre::Archive::unload | ( |  | ) | `[pure virtual]`

Unloads the archive.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

Implemented in Ogre::FileSystemArchive, and Ogre::ZipArchive.

## Member Data Documentation

String Ogre::Archive::mName`[protected]`

Archive name.

Definition at line 91 of file OgreArchive.h.

bool Ogre::Archive::mReadOnly`[protected]`

Read-only flag.

Definition at line 95 of file OgreArchive.h.

String Ogre::Archive::mType`[protected]`

Archive type code.

Definition at line 93 of file OgreArchive.h.

The documentation for this class was generated from the following file:

- OgreArchive.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:53